function y=Bc_dans_R(u);

global H jour rayon_orbital vitesse_rotation inclinaison periode_orbitale

% Calcul de la matrice de passage du repre Rc de consigne dont Yc pointe le soleil au repre R satellite xyz
%  	Xc est l'unitaire du produit vectoriel de S et de Y
%	Yc est l'unitaire soleil S
%	Zc complte le repre direct

% La variable d'entre est compose de 4 termes:
%	- u(1:3) le champ magntique en repre orbital
%	- u(4) le temps u de la simulation

B=u(1:3;

tps=u(4);

% *****************************   Unitaire soleil / XYZ ****************************************

teta=15*(12-H)*pi/180;                                        % Longitude nodale du soleil ( / Xn ), en radians

delta=23.45*sin(2*pi/365*(284+jour))*pi/180;                  % Dclinaison en radians formule de Fletcher

Us=[cos(delta)*cos(teta) cos(delta)*sin(teta) sin(delta)];    % Us unitaire soleil en axes XnYnZn

angle=vitesse_rotation*tps;                                   % Mouvement orbital

rayon_vecteur=[cos(angle) sin(angle)*cos(inclinaison) sin(angle)*sin(inclinaison)]*rayon_orbital;

% Matrice de passage de XYZ  XnYnZn

Pmat=[-sin(angle) cos(inclinaison)*cos(angle) sin(inclinaison)*cos(angle)
           0 -sin(inclinaison) cos(inclinaison)
                  cos(angle) cos(inclinaison)*sin(angle) sin(inclinaison)*sin(angle)];

% Composantes unitaire soleil dans XYZ



S_XYZ=Pmat*Us';         % Composantes de l'unitaire Soleil S dans XYZ, vecteur colonne

% ***************************   Matrice de passage de Rc  Ro = XYZ  ****************************

% ATTENTION prodvect donne le rsultat en colonne,  partir de vecteur colonnes

XX(1:3)=S_XYZ';XX(4:6)=[0 1 0]';                    % 2 vecteurs colonne

axe_xc=prodvect(XX)/norm(prodvect(XX));             % Sortie colonne

axe_yc=S_XYZ;                                       % Vecteur colonne

YY(1:3)=axe_xc;YY(4:6)=axe_yc;

axe_zc=prodvect(YY);                                % Vecteur colonne

% ----------------------------------   Matrice de passage Rc vers Rorbital -----------------------------

P_Rc2orb=[axe_xc axe_yc axe_zc];

% NB :Cette matrice servira  calculer les composantes de Bc dans Rc, connaissant
% 	les composantes de B en repre orbital==> (Bc)/Rc=P_Rc2Rorb*(B)/Rorbital
% 	Ces composantes seront celles de Bc consigne,dans le repre satellite

y=P_Rc2orb;

end


% ******************************************  Fin programme  ********************************************
% ----------------------------------   Matrice de passage Rorbital vers R   -----------------------------

%P_Rorb2R=passage(Q);



% ----------------------------------   **** Matrice de passage Rc vers R ****   -----------------------------

%Mat=P_Rc2orb*P_Rorb2R;

% ----------------------------------   **** Matrice de passage R vers Rc ****   -----------------------------




          