clear
clc
global Ir It Il Irl Itl Irt Asat etat_init vitesse_rotation altitude periode_orbitale H jour temps_energie
global points_trace vitesse_angul_mini Kbpoint w_spin axe_spin Pmax ang

% ****************************************  Zone des choix du type de simulation  **********************************
% ***                                      Choix de K_poinsot, REGUL, T_bascule                                  ***

 K_poinsot=1;                        % Permet par la mise  0 de simuler un mouvement de poinsot, sans moment externe
                                     % sans rgulation, ce qui permet de vrifier une bonne partie de la simulation 
                                     % ( notamment l'intgration )
 % NB pour les autres simulations cette constante vaut 1


 % ** Choix de simuler soit
      % Une rgulation Bpoint seulement ==> REGUL=0 durant toute la simulation

      % Une rgulation de mise en mode spin ds le dbut  ==> REGUL=1

      % Une rgulation dbutant par Bpoint seule, jusqu' un temps  choisir  T_bascule
      % se poursuivant par la mise en spin dbutant  T_bascule  ==> REGUL=2

 REGUL=1;

 % Temps de basculement de la rgulation Bpoint  celle de la vitesse de consigne
  T_bascule=1500; % valeur par dfaut

 if REGUL==0
   T_bascule=100000;
 end

 if REGUL==1
   T_bascule=0;
 end

 if REGUL==2
   T_bascule=1500;
 end


% Gain de la rgulation Bpoint ( type Damilano )devant la drive de B

 Kbpoint=600000;

% *************************************  Zone du choix du spin ( axe et valeur )  **********************************
% ***                                      Choix de axe_spin w_spin                                  ***
 
 H=21.5;jour=183; 

 temps_energie=5000;

 Pmax=18;                      % Puissance maxi des panneaux

 ang=35*pi/180;                % Inclinaison de la normale panneaux sur y

 w_spin=-0.00875*5;            % Comme conseill w_spin doit tre plus grande que w0=0.001

 axe_spin=[0 1 0];                    % Axe de spin, pour terminer avec une rotation w autour de +y etc...
 %axe_spin=[0 -cos(35*pi/180) -sin(35*pi/180)];      % Axe de spin, parallle  la normale aux panneaux.
 %axe_spin=[1 0 0];
 %axe_spin=[0 0 1];

 %axe_spin=[0 0.8 0.6]
 % *****************************************************************************************************************
 % Nombre de points du trac

 points_trace=60000;

 % **************************************   Donnes inertielles et orbitales   **************************************
 % Matrice d''inertie satellite

 Ir=22e-3;It=25e-3;Il=10e-3;Irt=5.344e-5;Irl=-1.998e-4;Itl=9.839e-4;         % Matrice quelconque

 %*Ir=32e-3;It=36e-3;Il=22e-3;Irt=0;Irl=0;Itl=0;    

 %*Ir=22e-3;It=25e-3;Il=10e-3;Irt=0;Irl=0;Itl=0;                           %  Matrice diagonale

 %*Ir=22e-3;It=36e-3;Il=22e-3;Irt=0;Irl=0;Itl=0;                     %  Matrice diagonale et de rvolution /y


 Asat=[Ir -Irt -Irl;
         -Irt It -Itl;
            -Irl -Itl Il];

 % Caractristiques de l'orbite du satellite

altitude_orbite=817;		% altitude satellite en km
rayon_orbital=(6378+altitude_orbite)*1000;
vitesse_rotation=sqrt(39.86e13/rayon_orbital^3);	% pulsation orbitale en rd/s
inclinaison=98.7*pi/180;
periode_orbitale=2*pi/vitesse_rotation;

%     CHOIX DES VITESSES APRES LA LANCEMENT  

% Normales V=0, moyennes V=1, Grandes V=2  Implicitement V=0 en vitesses normales

 V=0;    % *** Choix  faire  *****

%                          **********  VALEURS INITIALES VITESSES CLASSIQUES AU DEPART  ******

% Initialisation en vitesses (rd/s)

v_roulis0=0.06;
v_tangage0=-0.05;
v_lacet0=0.01;

% Initialisation en position (rd)

roulis0=0.1;
tangage0=-0.1;
lacet0=0.05;

if V==2
       %                              **********  VALEURS INITIALES GRANDES VITESSES AU DEPART  ******

   % Initialisation en vitesses (rd/s)

   v_roulis0=0.6;
   v_tangage0=0.2;
   v_lacet0=-0.1;

   % Initialisation en position (rd)

   roulis0=0.1;
   tangage0=-0.1;
   lacet0=0.05;
end

if V==1
   %                                     **********  VALEURS INITIALES MOYENNES  ******

   % Initialisation en vitesses (rd/s)

   v_roulis0=0.1;
   v_tangage0=0.3;
   v_lacet0=-0.1;

   % Initialisation en position (rd)

   roulis0=2;
   tangage0=-0.5;
   lacet0=1;

end
% 
%                                ***************** DONNEES PERTURBATIONS********************

% ******************** Donnes annexes*************************

mom_magn_res=0.01; %  Moment magntique rsiduel en Am

alpha=sqrt(1/3);beta=sqrt(1/3);gamma=sqrt(1/3); % Direction unitaire /satellite du moment rsiduel

cpl_aero1=0;
cpl_aero2=-3.6e-8;% COUPLE AERODYNAMIQUE
cpl_aero3=0;

% **********************************************************************

% ****** CALCULS D'INITIALISATION DU VECTEUR D'ETAT ********

% Rotation absolue compose de la rotation par rapport au repre orbital
% et de la rotation  vitesse_rotation porte par Y

vp0=v_roulis0+v_lacet0*sin(tangage0)+...
    vitesse_rotation*sin(lacet0)*cos(tangage0);

vq0=v_lacet0*cos(tangage0)*sin(roulis0)+v_tangage0*cos(roulis0)+...
    vitesse_rotation*(cos(lacet0)*cos(roulis0)+...
    sin(tangage0)*sin(roulis0)*sin(lacet0));

vr0=v_lacet0*cos(tangage0)*cos(roulis0)-v_tangage0*sin(roulis0)+...
    vitesse_rotation*(-cos(lacet0)*sin(roulis0)+...
    sin(tangage0)*cos(roulis0)*sin(lacet0));
   

% ---- Calcul du quaternion initial connaissant les angles initiaux

% Matrice de passage P de la base fixe XYZ  la base satellite xyz
%  l'instant initial

Pmat(1,1)=cos(tangage0)*cos(lacet0);
Pmat(1,2)=-sin(lacet0)*cos(roulis0)+cos(lacet0)*sin(roulis0)*sin(tangage0);
Pmat(1,3)=sin(lacet0)*sin(roulis0)+cos(lacet0)*cos(roulis0)*sin(tangage0);

Pmat(2,1)=cos(tangage0)*sin(lacet0);
Pmat(2,2)=cos(lacet0)*cos(roulis0)+sin(lacet0)*sin(roulis0)*sin(tangage0);
Pmat(2,3)=-cos(lacet0)*sin(roulis0)+sin(lacet0)*cos(roulis0)*sin(tangage0);

Pmat(3,1)=-sin(tangage0);
Pmat(3,2)=sin(roulis0)*cos(tangage0);
Pmat(3,3)=cos(roulis0)*cos(tangage0);

% determinant=det(Pmat),% ************* Bien vrifi ***********

% Calcul du quaternion initial
%
% Nous prenons toujours q0 >0 ou nul

trac=trace(Pmat);

qt00=(1+trac)^0.5/2;

qt10=(1-trac+2*Pmat(1,1))^0.5/2;

qt20=(1-trac+2*Pmat(2,2))^0.5/2;

qt30=(1-trac+2*Pmat(3,3))^0.5/2;

if abs(qt00)>1e-8, 
qt10=qt10*sign((Pmat(3,2)-Pmat(2,3))/4/qt00);
qt20=qt20*sign((Pmat(1,3)-Pmat(3,1))/4/qt00);
qt30=qt30*sign((-Pmat(1,2)+Pmat(2,1))/4/qt00);
end

if abs(qt10)>1e-8, 

qt20=qt20*sign((Pmat(1,2)+Pmat(2,1))/4/qt10);
qt30=qt30*sign((Pmat(1,3)+Pmat(3,1))/4/qt10);
qt00=qt00*sign((Pmat(3,2)-Pmat(2,3))/4/qt10);
end

if abs(qt20)>1e-8, 
qt10=qt10*sign((Pmat(1,2)+Pmat(2,1))/4/qt20);
qt30=qt30*sign((Pmat(2,3)+Pmat(3,2))/4/qt20);
qt00=qt00*sign((Pmat(1,3)-Pmat(3,1))/4/qt20);
end

if abs(qt30)>1e-8, 
qt20=qt20*sign((Pmat(3,2)+Pmat(2,3))/4/qt30);
qt10=qt10*sign((Pmat(1,3)+Pmat(3,1))/4/qt30);
qt00=qt00*sign((-Pmat(1,2)+Pmat(2,1))/4/qt30);
end

% Q=[qt00 qt10 qt20 qt30], %  ********* devrait avoir une norme 1

Q=[qt00 qt10 qt20 qt30]/norm([qt00 qt10 qt20 qt30]);

% normQ=norm(Q),% ******** vrifi *******

% energie=0.5*[vp0 vq0 vr0]*Asat*[vp0 vq0 vr0]',  %  ********  Energie devrait rester constante

etat_init=[vp0 vq0 vr0 Q(1) Q(2) Q(3) Q(4)]; 

% clear trac altitude qt00 qt10 qt20 qt30 vp0 vq0 vr0 Q Pmat

end








